#include "stdafx.h"
#include <fstream>
#include "agenda.h"

ContactList::ContactList() //constructor
{
}

vector<Contact*>* ContactList::getContacts() 
{
	return &contacts;
}

vector<Contact*>::iterator ContactList::posToIterator(int pos) //foloseste la stergerea unui contact
{
	vector<Contact*>::iterator it = contacts.begin();
	while(pos--)
		it++;
	return it;
}

CString ContactList::load(CString path) //incarcare din fisier
{
	static fstream f;
	static int nr = 0;
	char ln[256],*p,*tok,str[255];
	bool loadOk = true;
	Contact *cmpTmp;
	CString type, name, address, phone, age, det;
	if(!f.is_open())
	{
		f.open(path, ios::in);
		f.seekg(0);
		nr = 0;
	}
	ContactList::clearAll();
	while(!f.eof())
	{
		f.getline(ln,255);
		if(strlen(ln)<2)
			break;
		if(!strcmp(ln,"</company>"))
			return CString("");
		try 
		{
			p = strtok_s(ln,"|",&tok);
			if(!p)
				throw("The file is corrupt!");
			type = CString(p);
			p = strtok_s(NULL,"|",&tok);
			if(!p)
				throw("The file is corrupt!");
			name = CString(p);
			p = strtok_s(NULL,"|",&tok);
			if(!p)
				throw("The file is corrupt!");
			address = CString(p);
			p = strtok_s(NULL,"|",&tok);
			if(!p)
				throw("The file is corrupt!");
			phone = CString(p);
			p = strtok_s(NULL,"|",&tok);
			if(!p)
				throw("The file is corrupt!");
			age = CString(p);
			p = strtok_s(NULL,"|",&tok);
			if(p)
			{
				det = CString(p);
			}
		}
		catch(char *err)
		{
			strcpy_s(str,sizeof(str),err);
			loadOk = false;
			break;
		}
		if(loadOk)
		{
			if(type == CString("<acquaintance>"))
			{
				nr++;
				addContact(new Acquaintance(name, address, phone, age, det));
			}
			if(type == CString("<friend>"))
			{
				nr++;
				addContact(new Friend(name, address, phone, age, det));
			}
			if(type == CString("<contact>"))
			{
				nr++;
				addContact(new Contact(name, address, phone, age));
			}
			if(type == CString("<company>"))
			{
				nr++;
				addContact(cmpTmp = new Company(name, address, phone, age));
				((Company *)cmpTmp)->load(path);
			}
		}
	}
	f.close();
	if(loadOk)
	{
		_ltoa_s(nr,str,10,10);
		return CString(str) + CString(" contact(s) loaded successfully!");
	}
	return CString(str);
}

CString ContactList::save(CString path) //salveaza agenda in fisier
{
	static int nr = 0, lvl = 0;
	static fstream f;
	char str[11];
	CString type;
	if(!f.is_open())
	{
		f.open(path, ios::out);
		nr = 0;
	}
	for(i = contacts.begin(); i != contacts.end(); ++i)
	{
		type = (*i)->getType();
		type = type.MakeLower();
		f << "<" << type << ">" << "|" <<(*i)->getName() << "|" << (*i)->getAddress() << "|" << (*i)->getPhoneNo() << "|" << (*i)->getAge();
		if((*i)->getType()==CString("Acquaintance") || (*i)->getType() == CString("Friend"))
			f << "|" << (*i)->getDetail();
		if((*i)->getType()==CString("Company"))
		{
			lvl ++;
			f << endl;
			((Company *)(*i))->save(path);
			f << "</company>";
			lvl --;
		}
		f << endl;
		nr++;
	}
	if(lvl == 0)
	{
		_ltoa_s(nr,str,11,10);
		f.close();
		return CString(str) + CString(" contact(s) saved successfully!");
	}
	return CString("");
}

void ContactList::addContact(Contact *newContact) //adauga un nou contact
{
	contacts.push_back(newContact);
}

void ContactList::clearAll() //sterge tot din lista de contacte
{
	contacts.clear();
}

void ContactList::removeContact(vector<Contact*>::iterator i) //sterge un contact
{
	contacts.erase(i);
}

CString ContactList::getType()
{
	return CString("Agenda");
}
/*
Agenda::Agenda(char *owner) //constructor
{
	this->owner = CString(owner);
}

CString Agenda::getOwner() //returneaza proprietarul agendei
{
	return owner;
}

CString Agenda::getType() 
{
	return CString("Agenda");
}*/

Company::Company(CString newName, CString newAddress, CString newPhoneNo, CString newAge) : Contact(newName, newAddress, newPhoneNo, newAge), ContactList() //constructor
{
	//nothing
}

CString Company::getType()
{
	return CString("Company");
}
